Type: Package
Package: TheseusPlot
Title: Visualizing Decomposition of Differences in Rate Metrics
Version: 0.2.0
Authors@R: c(
    person("Koji", "Makiyama", , "hoxo.smile@gmail.com", role = c("aut", "cre", "cph")),
    person("Kazuyuki", "Sano", role = c("ctb", "wdc")),
    person("Shinichi", "Takayanagi", , "shinichi.takayanagi@gmail.com", role = "med"),
    person("Daisuke", "Ichikawa", role = "exp"),
    person("LY Corporation Analytics Solution Enhancement Team", role = "spn")
  )
Description: Provides tools for decomposing differences in rate metrics
    between two groups into contributions from individual subgroups and
    visualizing them as a "Theseus Plot". Inspired by the story of the
    Ship of Theseus, the method replaces subgroup data from one group with
    that of another step by step, recalculating the overall metric at each
    stage to quantify subgroup contributions.  A Theseus Plot combines the
    stepwise progression of a waterfall plot with the comparative bars of
    a bar chart, offering an intuitive way to understand subgroup-level
    effects.
License: MIT + file LICENSE
URL: https://github.com/hoxo-m/TheseusPlot,
        https://hoxo-m.github.io/TheseusPlot/
BugReports: https://github.com/hoxo-m/TheseusPlot/issues
Depends: R (>= 4.1.0)
Imports: dplyr, forcats, ggplot2, memoise, R6, rlang, stats, stringr,
        tibble, tidyr, waterfalls
Suggests: knitr, nycflights13, rmarkdown, testthat (>= 3.0.0)
Encoding: UTF-8
RoxygenNote: 7.3.3
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-04-09 17:26:02 UTC; akagi
Author: Koji Makiyama [aut, cre, cph],
  Kazuyuki Sano [ctb, wdc],
  Shinichi Takayanagi [med],
  Daisuke Ichikawa [exp],
  LY Corporation Analytics Solution Enhancement Team [spn]
Maintainer: Koji Makiyama <hoxo.smile@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-09 17:40:02 UTC
Built: R 4.6.0; ; 2026-04-30 04:55:34 UTC; unix

Type: Package
Package: TheseusPlot
Title: Visualizing Decomposition of Differences in Rate Metrics
Version: 0.2.0
Authors@R: c(
    person("Koji", "Makiyama", , "hoxo.smile@gmail.com", role = c("aut", "cre", "cph")),
    person("Kazuyuki", "Sano", role = c("ctb", "wdc")),
    person("Shinichi", "Takayanagi", , "shinichi.takayanagi@gmail.com", role = "med"),
    person("Daisuke", "Ichikawa", role = "exp"),
    person("LY Corporation Analytics Solution Enhancement Team", role = "spn")
  )
Description: Provides tools for decomposing differences in rate metrics
    between two groups into contributions from individual subgroups and
    visualizing them as a "Theseus Plot". Inspired by the story of the
    Ship of Theseus, the method replaces subgroup data from one group with
    that of another step by step, recalculating the overall metric at each
    stage to quantify subgroup contributions.  A Theseus Plot combines the
    stepwise progression of a waterfall plot with the comparative bars of
    a bar chart, offering an intuitive way to understand subgroup-level
    effects.
License: MIT + file LICENSE
URL: https://github.com/hoxo-m/TheseusPlot,
        https://hoxo-m.github.io/TheseusPlot/
BugReports: https://github.com/hoxo-m/TheseusPlot/issues
Depends: R (>= 4.1.0)
Imports: dplyr, forcats, ggplot2, memoise, R6, rlang, stats, stringr,
        tibble, tidyr, waterfalls
Suggests: knitr, nycflights13, rmarkdown, testthat (>= 3.0.0)
Encoding: UTF-8
RoxygenNote: 7.3.3
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-04-09 17:26:02 UTC; akagi
Author: Koji Makiyama [aut, cre, cph],
  Kazuyuki Sano [ctb, wdc],
  Shinichi Takayanagi [med],
  Daisuke Ichikawa [exp],
  LY Corporation Analytics Solution Enhancement Team [spn]
Maintainer: Koji Makiyama <hoxo.smile@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-09 17:40:02 UTC
Built: R 4.6.0; ; 2026-04-25 13:28:35 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# TheseusPlot: Visualizing Decomposition of Differences in Rate Metrics

<!-- badges: start -->

[![CRAN-version](https://www.r-pkg.org/badges/version/TheseusPlot)](https://cran.r-project.org/package=TheseusPlot)
[![CRAN-downloads](https://cranlogs.r-pkg.org/badges/TheseusPlot)](https://cran.r-project.org/package=TheseusPlot)
[![R-CMD-check](https://github.com/hoxo-m/TheseusPlot/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/hoxo-m/TheseusPlot/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

## 1. Overview

In data analysis, when a metric differs between two groups, we often
want to investigate whether a particular subgroup is driving that
difference. For example, when you observe a decline in a key metric
compared with the previous year, you may want to conduct a more detailed
analysis. In such an analysis, you might focus on one attribute, such as
gender, and examine whether the decline was driven by male users, female
users, or both. However, this type of analysis is challenging when the
metric is a rate, because each subgroup’s contribution to the rate
difference cannot be simply calculated, unlike in the case of volume
metrics.

To address this issue, we propose an approach inspired by the story of
the *[Ship of Theseus](https://en.wikipedia.org/wiki/Ship_of_Theseus)*.
This approach involves gradually replacing the components of one group
with those of another, recalculating the metric at each step. The change
in the metric at each step can then be interpreted as the contribution
of each subgroup to the overall difference.

For instance, suppose the click-through rate (CTR) was 6.2% in 2024 and
decreased to 5.2% in 2025. Again, we focus on gender. We replace the
male users in the 2024 dataset with the male users from 2025 and
recalculate the CTR. As a result, the CTR would drop by 0.8 percentage
points, reaching 5.4%. In this case, the contribution of male users to
the change in CTR is -0.8 percentage points. Next, we replace the female
users from 2024 with those from 2025. The dataset then consists entirely
of 2025 data, and CTR drops by 0.2 percentage points, reaching 5.2%.
Thus, the contribution of female users is -0.2 percentage points.

When visualized, the results appear as follows:

<img src="man/figures/README-overview-1.png" alt="" width="500" />

From this plot, we can see that the decline in CTR is primarily driven
by male users. We call this visualization the “Theseus Plot.”

The **TheseusPlot** package is designed to make it easy to generate
Theseus Plots for any column that defines subgroups.

## 2. Installation

You can install the **TheseusPlot** package from
[CRAN](https://cran.r-project.org/package=TheseusPlot).

``` r
install.packages("TheseusPlot")
```

You can install the development version from
[GitHub](https://github.com/hoxo-m/TheseusPlot) with:

``` r
remotes::install_github("hoxo-m/TheseusPlot")
```

## 3. Details

### 3.1 Prepare Data

To create Theseus Plots, you need two data frames that share common
columns.

We use the 2013 New York City flight data from
[nycflights13](https://cran.r-project.org/package=nycflights13) as a
demo dataset. Here, we will define the rate metric as the proportion of
flights that arrived on time. In December 2013, the on-time arrival rate
dropped substantially compared to November. We investigate the cause
using a Theseus Plot.

First, we create an `on_time` column in the data frame to indicate
whether each flight arrived on time. Next, we extract the flights for
November and December into separate data frames to form two comparison
groups. The on-time arrival rate was 83% in November and dropped to 67%
in December.

``` r
library(dplyr)
library(nycflights13)

data <- flights |> 
  filter(!is.na(arr_delay)) |>
  mutate(on_time = arr_delay <= 15) |>  # Arrived on time
  left_join(airlines, by = "carrier") |>
  mutate(carrier = name) |>  # Convert carrier abbreviations to full names
  select(year, month, day, origin, dest, carrier, dep_delay, on_time)

data |> head()
#> # A tibble: 6 × 8
#>    year month   day origin dest  carrier                dep_delay on_time
#>   <int> <int> <int> <chr>  <chr> <chr>                      <dbl> <lgl>  
#> 1  2013     1     1 EWR    IAH   United Air Lines Inc.          2 TRUE   
#> 2  2013     1     1 LGA    IAH   United Air Lines Inc.          4 FALSE  
#> 3  2013     1     1 JFK    MIA   American Airlines Inc.         2 FALSE  
#> 4  2013     1     1 JFK    BQN   JetBlue Airways               -1 TRUE   
#> 5  2013     1     1 LGA    ATL   Delta Air Lines Inc.          -6 TRUE   
#> 6  2013     1     1 EWR    ORD   United Air Lines Inc.         -4 TRUE

data_Nov <- data |> filter(month == 11)
data_Dec <- data |> filter(month == 12)

data_Nov |> summarise(on_time_rate = mean(on_time)) |> pull(on_time_rate)
#> [1] 0.8264803
data_Dec |> summarise(on_time_rate = mean(on_time)) |> pull(on_time_rate)
#> [1] 0.6738712
```

### 3.2 Basics

Using the two prepared data frames, we first create a `ship` object. The
`ship` object is an instance of the R6 class `ShipOfTheseus`, designed
to create Theseus Plots.

``` r
library(TheseusPlot)

ship <- create_ship(data_Nov, data_Dec, y = on_time, labels = c("November", "December"))
```

You can create a Theseus Plot by passing column names to the `plot`
method of a `ship` object. For example, to create a Theseus Plot for the
airport of origin:

``` r
ship$plot(origin)
```

<img src="man/figures/README-plot_origin-1.png" alt="" width="500" />

New York City has three major airports, and Newark Liberty International
Airport (EWR) accounted for the largest share of the decline in the
on-time arrival rate.

Note that the number of flights at each airport matters, as a larger
flight volume is expected to have a greater impact. To make this clear,
the Theseus Plot displays the sample size for each group within each
subgroup as a bar chart. From this, we see that the number of flights is
similar across airports, allowing for direct comparison of
contributions.

In summary, a Theseus Plot consists of two components:

- A waterfall plot showing how much each subgroup contributed to the
  change in the metric.
- A bar chart representing the sample size for each group within each
  subgroup.

A `ship` object also provides the `table` method to inspect the exact
values used in the Theseus Plot.

``` r
ship$table(origin)
#> # A tibble: 3 × 8
#>   origin contrib    n1    n2    x1    x2 rate1 rate2
#>   <chr>    <dbl> <int> <int> <int> <int> <dbl> <dbl>
#> 1 EWR    -0.0719  9603  9410  7995  5910 0.833 0.628
#> 2 JFK    -0.0502  8645  8923  7290  6142 0.843 0.688
#> 3 LGA    -0.0305  8723  8687  7006  6156 0.803 0.709
```

### 3.3 Flipping the Plot

When there are many subgroups, a Theseus Plot can become hard to read.
In such cases, you can swap the x- and y-axes for better visualization.

``` r
ship$plot_flip(carrier)
```

<img src="man/figures/README-plot_carrier-1.png" alt="" width="500" />

When the number of subgroups is large, those with small contributions
are automatically grouped together. By default, this happens when there
are more than 10 subgroups, but the threshold can be adjusted with the
`n` argument.

``` r
ship$plot_flip(carrier, n = 6)
```

<img src="man/figures/README-plot_carrier_n-1.png" alt="" width="500" />

From this plot, JetBlue Airways and United Air Lines appear to have the
largest contributions to the decline in on-time arrival rate.

### 3.4 Automatic Discretization of Continuous Values

Theseus Plots are primarily designed for categorical variables. When a
continuous column is provided, it is automatically discretized. For
example, we can create a Theseus Plot for departure delays.

``` r
ship$plot_flip(dep_delay)
```

<img src="man/figures/README-plot_dep_delay-1.png" alt="" width="500" />

By default, continuous variables are discretized so that each subgroup
has roughly equal sample sizes, with the number of bins set to 10. You
can modify these settings by passing the return value of
`continuous_config()` to the `continuous` argument.

``` r
ship$plot_flip(dep_delay, continuous = continuous_config(n = 3))
```

<img src="man/figures/README-plot_dep_delay_n-1.png" alt="" width="500" />

This result shows that both a decrease in on-time departures and an
increase in delayed departures contributed to the decline in on-time
arrival rate.

### 3.5 Controlling Category Order with Factors

By default, character columns are ordered by contribution size in
`table()`, `plot()`, and `plot_flip()`. If you want to use a specific
order instead, convert the column to a factor. For factor columns,
TheseusPlot respects the order of the factor levels.

This is useful when the categories have a natural order, such as
`"Low"`, `"Medium"`, and `"High"`, or when you want to define the order
manually.

For example, suppose we classify departure delays into three categories:
`"Early"`, `"On-time"`, and `"Delayed"`.

When `departure_type` is a character column, the categories are ordered
by their contributions.

``` r
to_departure_type <- function(x) {
  case_when(x <= -4 ~ "Early", x <= 4 ~ "On-time", x > 4 ~ "Delayed")
}

data_Nov <- data_Nov |> mutate(departure_type = to_departure_type(dep_delay))
data_Dec <- data_Dec |> mutate(departure_type = to_departure_type(dep_delay))

ship <- create_ship(data_Nov, data_Dec, y = on_time, labels = c("November", "December"))

ship$plot_flip(departure_type)
```

<img src="man/figures/README-no_factor_column-1.png" alt="" width="500" />

To display the categories in a meaningful order, convert
`departure_type` to a factor and specify the level order.

``` r
to_departure_type <- function(x) {
  types <- case_when(x <= -4 ~ "Early", x <= 4 ~ "On-time", x > 4 ~ "Delayed")
  types <- factor(types, levels = c("Early", "On-time", "Delayed"))
  types
}

data_Nov <- data_Nov |> mutate(departure_type = to_departure_type(dep_delay))
data_Dec <- data_Dec |> mutate(departure_type = to_departure_type(dep_delay))

ship <- create_ship(data_Nov, data_Dec, y = on_time, labels = c("November", "December"))

ship$plot_flip(departure_type)
```

<img src="man/figures/README-factor_column-1.png" alt="" width="500" />

You can change the factor levels to display the categories in any order
you choose.

<!-- README.md is generated from README.Rmd. Please edit that file -->

# TheseusPlot: Visualizing Decomposition of Differences in Rate Metrics

<!-- badges: start -->

[![CRAN-version](https://www.r-pkg.org/badges/version/TheseusPlot)](https://cran.r-project.org/package=TheseusPlot)
[![CRAN-downloads](https://cranlogs.r-pkg.org/badges/TheseusPlot)](https://cran.r-project.org/package=TheseusPlot)
[![R-CMD-check](https://github.com/hoxo-m/TheseusPlot/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/hoxo-m/TheseusPlot/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

## 1. Overview

In data analysis, when a metric differs between two groups, we sometimes
want to investigate whether a particular subgroup is driving that
difference. For example, when a key metric decline is detected compared
to the previous year, you may want to conduct a more detailed analysis.
In this analysis, you may focus on gender among the attributes and
examine whether the decline occurred among male, female, or both.
However, this type of analysis is challenging when the metric is a rate,
because the magnitude of each subgroup’s contribution to the rate cannot
be simply calculated, unlike in the case of volume metrics.

To address this issue, we propose an approach inspired by the story of
the *[Ship of Theseus](https://en.wikipedia.org/wiki/Ship_of_Theseus)*.
This approach involves gradually replacing the components of one group
with those of another, recalculating the metric at each step. The change
in the metric at each step can then be interpreted as the contribution
of each subgroup to the overall difference.

For instance, suppose the metric was 6.2% in 2024 and decreased to 5.2%
in 2025. Again, we focus on gender. We replace the male data within the
2024 dataset with the male data from 2025 and recalculate the metric. As
a result, the metric would drop by 0.8 percentage points, reaching 5.4%.
In this case, the contribution of the male group to the change in the
metric is -0.8 percentage points. Next, we replace the female data from
2024 with that from 2025. The dataset then consists entirely of 2025
data, and the metric drops by 0.2 percentage points, reaching 5.2%.
Thus, the contribution of the female group is -0.2 percentage points.

When visualized, the results appear as follows:

<img src="man/figures/README-overview-1.png" alt="" width="500" />

From this plot, we can see that the decline in the metric is primarily
driven by the male group. We call this visualization the “Theseus Plot.”

The **TheseusPlot** package is designed to make it easy to generate
Theseus Plots for various attributes.

## 2. Installation

You can install the **TheseusPlot** package from
[CRAN](https://cran.r-project.org/package=TheseusPlot).

``` r
install.packages("TheseusPlot")
```

You can install the development version from
[GitHub](https://github.com/hoxo-m/TheseusPlot) with:

``` r
remotes::install_github("hoxo-m/TheseusPlot")
```

## 3. Details

### 3.1 Prepare Data

To create Theseus plots, you need two data frames that share common
columns.

We use the 2013 New York City flight data from
[nycflights13](https://cran.r-project.org/package=nycflights13) as a
demo dataset. Here, we will define the rate metric as the proportion of
flights that arrived on time. In December 2013, the on-time arrival rate
dropped substantially compared to November. We investigate the cause
using a Theseus plot.

First, we create an `on_time` column in the data frame to indicate
whether each flight arrived on time. Next, we extract the flights for
November and December into separate data frames to form two comparison
groups. The on-time arrival rate was 64% in November and dropped to 47%
in December.

``` r
library(dplyr)
library(nycflights13)

data <- flights |> 
  filter(!is.na(arr_delay)) |>
  mutate(on_time = arr_delay <= 15) |>  # Arrived on time
  left_join(airlines, by = "carrier") |>
  mutate(carrier = name) |>  # Convert carrier abbreviations to full names
  select(year, month, day, origin, dest, carrier, dep_delay, on_time)

data |> head()
#> # A tibble: 6 × 8
#>    year month   day origin dest  carrier                dep_delay on_time
#>   <int> <int> <int> <chr>  <chr> <chr>                      <dbl> <lgl>  
#> 1  2013     1     1 EWR    IAH   United Air Lines Inc.          2 TRUE   
#> 2  2013     1     1 LGA    IAH   United Air Lines Inc.          4 FALSE  
#> 3  2013     1     1 JFK    MIA   American Airlines Inc.         2 FALSE  
#> 4  2013     1     1 JFK    BQN   JetBlue Airways               -1 TRUE   
#> 5  2013     1     1 LGA    ATL   Delta Air Lines Inc.          -6 TRUE   
#> 6  2013     1     1 EWR    ORD   United Air Lines Inc.         -4 TRUE

data_Nov <- data |> filter(month == 11)
data_Dec <- data |> filter(month == 12)

data_Nov |> summarise(on_time_rate = mean(on_time)) |> pull(on_time_rate)
#> [1] 0.8264803
data_Dec |> summarise(on_time_rate = mean(on_time)) |> pull(on_time_rate)
#> [1] 0.6738712
```

### 3.2 Basics

Using the two prepared data frames, we first create a `ship` object. The
`ship` object is an instance of the R6 class `ShipOfTheseus`, designed
to create Theseus plots.

``` r
library(TheseusPlot)

ship <- create_ship(data_Nov, data_Dec, y = on_time, labels = c("November", "December"))
```

You can create a Theseus plot by passing column names to the `plot`
method of a `ship` object. For example, to create a Theseus plot for the
airport of origin:

``` r
ship$plot(origin)
```

<img src="man/figures/README-plot_origin-1.png" alt="" width="500" />

New York City has three major airports, and Newark Liberty International
Airport (EWR) accounted for the largest share of the decline in the
on-time arrival rate.

Note that the number of flights at each airport matters, as a larger
flight volume is expected to have a greater impact. To make this clear,
the Theseus plot displays the data size for each group within each
subgroup as a bar chart. From this, we see that the number of flights is
similar across airports, allowing for direct comparison of
contributions.

In summary, a Theseus plot consists of two components:

- A waterfall plot showing how much each subgroup contributed to the
  change in the metric.
- A bar chart representing the sample size for each group within each
  subgroup.

A `ship` object also provides the `table` method to inspect the exact
values used in the Theseus plot.

``` r
ship$table(origin)
#> # A tibble: 3 × 8
#>   origin contrib    n1    n2    x1    x2 rate1 rate2
#>   <chr>    <dbl> <int> <int> <int> <int> <dbl> <dbl>
#> 1 EWR    -0.0719  9603  9410  7995  5910 0.833 0.628
#> 2 JFK    -0.0502  8645  8923  7290  6142 0.843 0.688
#> 3 LGA    -0.0305  8723  8687  7006  6156 0.803 0.709
```

### 3.3 Flipping the Plot

When there are many subgroups, a Theseus plot can become hard to read.
In such cases, you can swap the x- and y-axes for better visualization.

``` r
ship$plot_flip(carrier)
```

<img src="man/figures/README-plot_carrier-1.png" alt="" width="500" />

When the number of subgroups is large, those with small contributions
are automatically grouped together. By default, this happens when there
are more than 10 subgroups, but the threshold can be adjusted with the
`n` argument.

``` r
ship$plot_flip(carrier, n = 6)
```

<img src="man/figures/README-prot_carrier_n-1.png" alt="" width="500" />

From this plot, JetBlue Airways and United Air Lines appear to have the
largest contributions to the decline in on-time arrival rate.

### 3.4 Automatic Discretization of Continuous Values

Theseus plots do not directly support continuous variables. If a
continuous column is provided, it is automatically discretized. For
example, we can create a Theseus plot for departure delays.

``` r
ship$plot_flip(dep_delay)
```

<img src="man/figures/README-plot_dep_delay-1.png" alt="" width="500" />

By default, continuous variables are discretized so that each subgroup
has roughly equal sample sizes, with the number of bins set to 10. You
can modify these settings by passing the return value of
`continuous_config()` to the `continuous` argument.

``` r
ship$plot_flip(dep_delay, continuous = continuous_config(n = 3))
```

<img src="man/figures/README-plot_dep_delay_n-1.png" alt="" width="500" />

This result shows that both a decrease in on-time departures and an
increase in delayed departures contributed to the decline in on-time
arrival rate.

### 3.5 Ordering for Factor Columns

If a subgroup column is a factor, `table()` and `plot()` respect its
factor level order. This is useful when you want to keep a meaningful
predefined order, such as `"Low"`, `"Medium"`, and `"High"`, instead of
ordering categories by their contributions.

``` r
segment_order <- c("Low", "Medium", "High")

data1 <- data.frame(
  segment = factor(c("Low", "Low", "Medium", "Medium", "High", "High"), levels = segment_order),
  y = c(1, 1, 1, 0, 1, 1)
)

data2 <- data.frame(
  segment = factor(c("Low", "Low", "Medium", "Medium", "High", "High"), levels = segment_order),
  y = c(1, 0, 1, 1, 0, 0)
)

ship <- create_ship(data1, data2, y = y, labels = c("Group 1", "Group 2"))

ship$table(segment)
#> # A tibble: 3 × 8
#>   segment contrib    n1    n2    x1    x2 rate1 rate2
#>   <fct>     <dbl> <int> <int> <dbl> <dbl> <dbl> <dbl>
#> 1 Low      -0.167     2     2     2     1   1     0.5
#> 2 Medium    0.167     2     2     1     2   0.5   1  
#> 3 High     -0.333     2     2     2     0   1     0

ship$plot(segment)
```

<img src="man/figures/README-factor_column-1.png" alt="" width="500" />

Even if the contribution of `"High"` is larger than that of `"Low"` or
`"Medium"`, the rows and bars are shown in the order
`"Low" -> "Medium" -> "High"` because `segment` is a factor.

By contrast, if `segment` were a character column, the output would be
ordered by contribution rather than by a predefined level order.

#' Creates a Ship Object for Generating Theseus Plots
#'
#' @description
#' Creates a ship object, which serves as a container for data and methods to
#' generate Theseus plots for decomposing differences in rate metrics.
#'
#' @param data1 data frame representing the first group (e.g., the baseline
#'   data).
#' @param data2 data frame representing the second group (e.g., the comparison
#'   data).
#' @param xlab string specifying the x-axis label for plots. If \code{NULL}
#'   (default), no label is displayed.
#' @param y column name specifying the outcome variable used to compute the rate
#'   metric (default is \code{"y"}). Typically, this is a binary indicator
#'   (e.g., 0/1) that is aggregated to form rates.
#' @param labels character vector of length 2 giving the labels for the two
#'   groups. The first corresponds to \code{data1}, the second to \code{data2}.
#'   Default is \code{c("Baseline", "Comparison")}.
#' @param ylab string specifying the y-axis label for plots. If \code{NULL}
#'   (default), no label is displayed.
#' @param digits integer indicating the number of decimal places to use for
#'   displaying numeric values (default is \code{1}).
#' @param text_size numeric value specifying the relative size of text elements
#'   in plots (default is \code{1.0}).
#'
#' @return A \link{ShipOfTheseus} object, which can be used with \code{plot()}
#'   to create Theseus plots.
#'
#' @examples
#' library(dplyr)
#' library(TheseusPlot)
#'
#' data <- nycflights13::flights |>
#'   filter(!is.na(arr_delay)) |>
#'   mutate(on_time = arr_delay <= 0)
#'
#' data1 <- data |> filter(month == 1)
#' data2 <- data |> filter(month == 2)
#'
#' create_ship(data1, data2, y = on_time)
#'
#' @export
create_ship <- function(data1, data2, y = "y", labels = c("Baseline", "Comparison"),
                        xlab = NULL, ylab = NULL, digits = 1L, text_size = 1.0) {
  ShipOfTheseus$new(data1, data2, rlang::enquo(y), labels, xlab = xlab, 
                    ylab = ylab, digits = digits, text_size = text_size)
}

test_that("table() handles missing and asymmetric categories correctly", {
  data1 <- data.frame(
    group = c("A", "A", "B", NA),
    y = c(1, 1, 0, 1),
    stringsAsFactors = FALSE
  )
  
  data2 <- data.frame(
    group = c("A", "C", "C", NA),
    y = c(0, 1, 0, 0),
    stringsAsFactors = FALSE
  )
  
  ship <- create_ship(data1, data2, y = y)
  tbl <- ship$table(group, n = Inf)
  
  # Missing values and one-sided categories are retained
  expect_setequal(tbl$group, c("A", "B", "C", "(Missing)"))
  
  # Absent categories are zero-filled
  expect_equal(tbl$n1[tbl$group == "C"], 0L)
  expect_equal(tbl$x1[tbl$group == "C"], 0L)
  expect_equal(tbl$n2[tbl$group == "B"], 0L)
  expect_equal(tbl$x2[tbl$group == "B"], 0L)
  
  # Contributions add up to the overall difference
  overall_diff <- mean(data2$y) - mean(data1$y)
  expect_equal(sum(tbl$contrib), overall_diff, tolerance = 1e-12)
  
  # Table totals match the input data
  expect_equal(sum(tbl$n1), nrow(data1))
  expect_equal(sum(tbl$n2), nrow(data2))
})

#' Continuous Variable Configuration for Theseus Plot
#'
#' @description
#' The \code{continuous_config()} function creates a configuration object for
#' handling continuous variables in Theseus plots. It controls how continuous
#' data is binned into discrete categories for contribution calculations and
#' visualization.
#'
#' @param n integer. Number of bins to create for a continuous variable.
#' @param pretty logical. If TRUE, use pretty breaks for bin edges.
#' @param split string. Method for binning continuous variables. Options are:
#' \describe{
#'   \item{\code{"count"}}{divide the variable into bins with roughly equal number of observations.}
#'   \item{\code{"width"}}{divide the range of the variable into equal-width bins.}
#'   \item{\code{"rate"}}{divide based on differences in outcome rates between bins.}
#' }
#' @param breaks numeric vector specifying custom break points.
#'
#' @return A list containing binning parameters (\code{n}, \code{pretty},
#'   \code{split}, \code{breaks}) to be used in plotting or contribution
#'   calculations for continuous variables.
#'
#' @examples
#' library(TheseusPlot)
#' continuous_config(n = 5, pretty = FALSE, split = "rate")
#'
#' @export
continuous_config <- function(n = 10L, pretty = TRUE,
                              split = c("count", "width", "rate"),
                              breaks = NULL) {
  split <- match.arg(split)
  list(n = n, pretty = pretty, split = split, breaks = breaks)
}

compute_breaks <- function(values, break_num = 10L) {
  if (any(is.na(values))) {
    break_num <- break_num - 1L
  }
  breaks <- stats::quantile(values, probs = seq(0, 1, length.out = break_num + 1), na.rm = TRUE)
  breaks <- unname(breaks)
  breaks
}

pretty_breaks <- function(breaks) {
  digits <- ifelse(breaks == 0, 0, floor(log10(abs(breaks))) + 1L)
  base <- 10 ^ (digits - 2)
  ifelse(sign(breaks) < 0, floor(breaks / base), ceiling(breaks / base)) * base
}

#' @importFrom R6 R6Class
NULL

#' An R6 Class for Generating Theseus Plot
#'
#' @description
#' The \code{ShipOfTheseus} class decomposes the difference in outcome rates
#' between two datasets. For a selected column, it computes subgroup
#' contributions, summarizes the results in tables, and visualizes them as
#' waterfall-style Theseus Plots.
#'
#' @import dplyr ggplot2 stringr
#'
#' @export
ShipOfTheseus <- R6::R6Class(
  "ShipOfTheseus",

  private = list(
    labels = NULL,
    compute_scores = NULL,
    to_factor = NULL,
    compute_contribution = NULL,
    compute_info = NULL,
    compute_size = NULL,
    xlab = NULL,
    ylab = NULL,
    digits = NULL,
    text_size = NULL,
    
    #' @importFrom forcats fct_na_value_to_level
    #' @importFrom tidyr replace_na
    prepare_input_data = function(data, outcome) {
      data |>
        # Fill missing values while preserving column types, since downstream
        # table()/plot() handle character and factor columns differently
        mutate(
          across(where(is.character), \(x) replace_na(x, "(Missing)")),
          across(where(is.factor) & where(anyNA), \(x) fct_na_value_to_level(x, level = "(Missing)"))
        ) |>
        # Standardize the outcome column name for internal use
        rename(.outcome = all_of(outcome))
    },
    
    prepare_plot_data = function(column_name, n, levels, continuous, flip) {
      df_contrib <- self$table(!!rlang::sym(column_name), n = n, continuous = continuous) |>
        select(items = 1L, contrib)
      
      if (flip) {
        df_contrib <- df_contrib |> mutate(contrib = -contrib)
      }
      
      is_factor <- is.factor(df_contrib$items)
      
      if (is_factor) {
        df_contrib <- if (flip) arrange(df_contrib, desc(items)) else arrange(df_contrib, items)
      } else {
        df_contrib <- arrange(df_contrib, contrib)
      }
      
      data_size <- private$compute_size(
        column_name,
        target = df_contrib$items,
        continuous = continuous
      )
      
      if (!is.null(levels)) {
        levels <- as.character(levels)
        if (flip) levels <- rev(levels)
        df_contrib <- data.frame(items = levels) |> inner_join(df_contrib, by = "items")
      }
      
      list(
        df_contrib = df_contrib,
        data_size = data_size
      )
    },
    
    compute_bar_height = function(data_waterfall, data_size, max_score, main_item = NULL,
                                  bar_max_value = NULL, bar_min_ratio = 0.15) {
      if (is.null(main_item) & is.null(bar_max_value)) {
        max_amount <- max_score * 100 * bar_min_ratio
        n_max <- data_size |> tail(-1) |> 
          slice_max(order_by = n, n = 1, with_ties = FALSE) |> pull(n)
      } else if(!is.null(main_item)) {
        max_amount <- data_waterfall |> filter(items == main_item) |> pull(contrib) |> abs()
        n_max <- data_size |> filter(items == main_item) |> pull(n) |> max()
      } else if(!is.null(bar_max_value)) {
        max_amount <- bar_max_value
        n_max <- data_size |> filter(n == max(n)) |> pull(n) |> max()
      }
      max_amount / n_max
    }
  ),

  public = list(
    #' @description
    #' The constructor of the \code{ShipOfTheseus} class.
    #'
    #' @param data1 data frame representing the first group (e.g., the baseline
    #'   data).
    #' @param data2 data frame representing the second group (e.g., the
    #'   comparison data).
    #' @param outcome string specifying the outcome variable used to compute the
    #'   rate metric (default is \code{"y"}). Typically, this is a binary
    #'   indicator (e.g., 0/1) that is aggregated to form rates.
    #' @param labels character vector of length 2 giving the labels for the two
    #'   groups. The first corresponds to \code{data1}, the second to
    #'   \code{data2}. Default is \code{c("Baseline", "Comparison")}.
    #' @param xlab string specifying the x-axis label for plots. If \code{NULL}
    #'   (default), no label is displayed.
    #' @param ylab string specifying the y-axis label for plots. If \code{NULL}
    #'   (default), no label is displayed.
    #' @param digits integer indicating the number of decimal places to use for
    #'   displaying numeric values (default is \code{1}).
    #' @param text_size numeric value specifying the relative size of text
    #'   elements in plots (default is \code{1.0}).
    #'
    #' @return A \code{ShipOfTheseus} object, which can be used with
    #'   \code{plot()} to create Theseus plots.
    #'
    #' @importFrom forcats fct_c fct_na_value_to_level
    #' @importFrom memoise memoise
    #' @importFrom tibble tibble
    #' @importFrom tidyr replace_na
    initialize = function(data1, data2, outcome, labels, xlab, ylab, digits, text_size) {
      outcome <- rlang::quo_squash(outcome) |> rlang::as_string()
      labels <- as.character(labels)

      data1 <- private$prepare_input_data(data1, outcome)
      data2 <- private$prepare_input_data(data2, outcome)

      private$labels <- labels
      private$xlab <- xlab 
      private$ylab <- ylab
      private$digits <- digits
      private$text_size <- text_size

      private$compute_scores <- memoise(function(column_name) {
        score1 <- data1 |> summarise(score = mean(.outcome)) |> pull(score)
        score2 <- data2 |> summarise(score = mean(.outcome)) |> pull(score)
        c(score1, score2)
      })

      private$to_factor <- memoise(function(column_name, continuous) {
        if (is.null(continuous$breaks)) {
          values <- c(data1[[column_name]], data2[[column_name]])
          break_num <- continuous$n
          if (continuous$split == "width") {
            if (any(is.na(values))) break_num <- break_num - 1L
            min <- min(values, na.rm = TRUE)
            max <- max(values, na.rm = TRUE)
            breaks <- seq(min, max, length.out = break_num + 1)
          } else if(continuous$split == "count") {
            breaks <- compute_breaks(values, break_num = break_num)
          } else {
            breaks <- compute_breaks(values, break_num = break_num * 20L)
            breaks <- sort(unique(breaks))
            d1 <- data1 |>
              select(x = !!rlang::sym(column_name), y = .outcome) |>
              filter(!is.na(x))
            d2 <- data2 |>
              select(x = !!rlang::sym(column_name), y = .outcome) |>
              filter(!is.na(x))
            while (length(breaks) > break_num + 1L) {
              data1_tmp <- d1 |>
                mutate(x = cut(x, breaks = breaks, include.lowest = TRUE)) |>
                group_by(x) |>
                summarise(y = mean(y)) |>
                mutate(diff1 = abs(lead(y) - y))
              data2_tmp <- d2 |>
                mutate(x = cut(x, breaks = breaks, include.lowest = TRUE)) |>
                group_by(x) |>
                summarise(y = mean(y)) |>
                mutate(diff2 = abs(lead(y) - y))
              data_tmp <- data1_tmp |> left_join(data2_tmp, by = "x") |>
                mutate(diff = sqrt(diff1^2 + diff2^2))
              breaks <- breaks[-(which.min(data_tmp$diff) + 1L)]
            }
          }
          if (continuous$pretty) {
            breaks <- pretty_breaks(breaks)
            if (any(table(breaks) >= 2)) {
              warning("Prettying breaks reduced the number of breaks. Try pretty = FALSE.")
              breaks <- unique(breaks)
            }
          }
        } else {
          breaks <- continuous$breaks
        }

        df1 <- data1
        df2 <- data2

        df1[[column_name]] <- cut(df1[[column_name]], breaks = breaks, include.lowest = TRUE, dig.lab = 50)
        df2[[column_name]] <- cut(df2[[column_name]], breaks = breaks, include.lowest = TRUE, dig.lab = 50)

        df1[[column_name]] <- fct_na_value_to_level(df1[[column_name]], level = "(Missing)")
        df2[[column_name]] <- fct_na_value_to_level(df2[[column_name]], level = "(Missing)")

        list(df1, df2)
      })

      private$compute_contribution <- memoise(function(column_name, continuous) {
        if (is.numeric(data1[[column_name]])) {
          data_list <- private$to_factor(column_name, continuous)
          data1 <- data_list[[1]]
          data2 <- data_list[[2]]
        }

        df1 <- data1 |>
          group_by(!!rlang::sym(column_name)) |>
          summarise(y = sum(.outcome), n = n(), rate = y / n)
        df2 <- data2 |>
          group_by(!!rlang::sym(column_name)) |>
          summarise(y = sum(.outcome), n = n(), rate = y / n)

        names1 <- df1[[column_name]]
        names2 <- df2[[column_name]]

        scores <- private$compute_scores(column_name)
        score1 <- scores[1]
        score2 <- scores[2]

        df_contrib <- tibble()
        for (name in names2) {
          df_temp <- df1
          if (name %in% names1) {
            df_temp[df_temp[[column_name]] == name, ] <- df2[df2[[column_name]] == name, ]
          } else {
            df_temp <- rbind(df_temp, df2[df2[[column_name]] == name, ])
          }

          score_new <- df_temp |> summarise(score = sum(y) / sum(n)) |> pull(score)
          diff <- score_new - score1
          res <- tibble(items = name, amount = diff)
          df_contrib <- rbind(df_contrib, res)
        }
        for (name in names1) {
          df_temp <- df2
          if (name %in% names2) {
            df_temp[df_temp[[column_name]] == name, ] <- df1[df1[[column_name]] == name, ]
          } else {
            df_temp <- rbind(df_temp, df1[df1[[column_name]] == name, ])
          }

          score_new <- df_temp |> summarise(score = sum(y) / sum(n)) |> pull(score)
          diff <- score2 - score_new
          res <- tibble(items = name, amount = diff)
          df_contrib <- rbind(df_contrib, res)
        }

        if (is.factor(names1)) {
          names <- fct_c(names1, names2)
          df_contrib <- df_contrib |>
            mutate(items = factor(items, levels = levels(names)))
        }
        df_contrib |>
          group_by(items) |>
          summarise(contrib = mean(amount)) |>
          mutate(contrib = (score2 - score1) * contrib / sum(contrib))
      })

      private$compute_info <- memoise(function(column_name, continuous) {
        if (is.numeric(data1[[column_name]])) {
          data_list <- private$to_factor(column_name, continuous)
          data1 <- data_list[[1]]
          data2 <- data_list[[2]]
        }

        data1_info <- data1 |>
          group_by(items = !!rlang::sym(column_name)) |>
          summarise(n1 = n(), x1 = sum(.outcome), rate1 = x1 / n1)
        data2_info <- data2 |>
          group_by(items = !!rlang::sym(column_name)) |>
          summarise(n2 = n(), x2 = sum(.outcome), rate2 = x2 / n2)
        data1_info |> full_join(data2_info, by = "items") |>
          select(items, starts_with("n"), starts_with("x"), starts_with("rate")) |>
          replace_na(list(n1 = 0L, n2 = 0L, x1 = 0L, x2 = 0L))
      })

      private$compute_size <- memoise(function(column_name, target, continuous) {
        if (is.numeric(data1[[column_name]])) {
          data_list <- private$to_factor(column_name, continuous)
          data1 <- data_list[[1]]
          data2 <- data_list[[2]]
        }

        data1_size <- data1 |>
          filter(!!rlang::sym(column_name) %in% target) |>
          count(items = !!rlang::sym(column_name)) |>
          mutate(type = labels[1])
        data2_size <- data2 |>
          filter(!!rlang::sym(column_name) %in% target) |>
          count(items = !!rlang::sym(column_name)) |>
          mutate(type = labels[2])
        item_names <- unique(c(data1_size$items, data2_size$items))
        other_name <- target[!(target %in% item_names)]

        if (length(other_name) == 0L) {
          bind_rows(data1_size, data2_size)
        } else {
          data1_size_other <- data1 |>
            filter(!(!!rlang::sym(column_name) %in% target)) |>
            count() |>
            mutate(type = labels[1], items = other_name)
          data2_size_other <- data2 |>
            filter(!(!!rlang::sym(column_name) %in% target)) |>
            count() |>
            mutate(type = labels[2], items = other_name)
          if (is.factor(data1_size$items)) {
            data1_size <- data1_size |> mutate(items = as.character(items))
            data2_size <- data2_size |> mutate(items = as.character(items))
            bind_rows(data1_size, data1_size_other, data2_size, data2_size_other)
          } else {
            bind_rows(data1_size, data1_size_other, data2_size, data2_size_other)
          }
        }
      })
    },

    #' @description
    #' Generate a contribution table for a given column.
    #'
    #' @param column_name string. The name of the column to analyze.
    #' @param n integer. Maximum number of top contributing subgroups to display.
    #'   If the number of subgroups exceeds `n`, the remaining are aggregated.
    #' @param continuous list. A configuration list for handling continuous
    #'   variables (e.g., specifying number of bins or custom breaks).
    #'
    #' @return A tibble summarizing subgroup contributions to the difference
    #'   between the two groups, including counts, total outcomes, and rates
    #'   for each subgroup.
    table = function(column_name, n = Inf, continuous = continuous_config()) {
      column_name <- rlang::ensym(column_name) |> rlang::as_string()
      data_contrib <- private$compute_contribution(column_name, continuous)
      data_info <- private$compute_info(column_name, continuous)
      result <- data_contrib |>
        left_join(data_info, by = "items")
      is_factor <- is.factor(result$items)
      if (is_factor) {
        levels <- levels(result$items)
        result <- result |> arrange(items)
      } else {
        result <- result |> arrange(desc(abs(contrib)))
      }
      n_items <- nrow(result)
      if (n_items > n) {
        n_other <- n_items - n + 1L
        result_head <- head(result |> arrange(desc(abs(contrib))), n - 1L) |>
          mutate(items = as.character(items))
        result_tail <- tail(result |> arrange(desc(abs(contrib))), n_other)
        result_other <- result_tail |>
          mutate(items = str_glue("Sum of {n_other} other subgroups")) |>
          group_by(items) |>
          summarise_at(vars(contrib, n1, n2, x1, x2), sum) |>
          mutate(rate1 = x1 / n1, rate2 = x2 / n2)
        result <- bind_rows(result_head, result_other)
        if (is_factor) {
          levels <- c(levels, str_glue("Sum of {n_other} other subgroups"))
          result <- result |>
            mutate(items = factor(items, levels = levels)) |>
            arrange(items)
        }
      }
      names(result)[1] <- column_name
      result
    },

    #' @description
    #' Generate a Theseus plot for a specified column
    #'
    #' @param column_name The name of the column to visualize.
    #' @param n integer. Maximum number of top contributing subgroups to display.
    #'   Remaining subgroups are aggregated if necessary.
    #' @param main_item string. The subgroup used as the reference for scaling
    #'   the bar heights.
    #' @param bar_max_value numeric. Maximum value for scaling the contribution bars.
    #' @param levels character vector specifying the display order of subgroups.
    #' @param continuous list. Configuration for handling continuous variables
    #'   (e.g., number of bins or custom breaks).
    #'
    #' @return A ggplot object representing the Theseus Plot for the specified column.
    #'
    #' @importFrom tibble tibble
    #' @importFrom waterfalls waterfall
    plot = function(column_name, n = 10L, main_item = NULL, bar_max_value = NULL,
                    levels = NULL, continuous = continuous_config()) {
      column_name <- rlang::ensym(column_name) |> rlang::as_string()

      labels <- private$labels
      scores <- private$compute_scores(column_name)
      score1 <- scores[1]
      max_score <- max(scores)
      plot_data <- private$prepare_plot_data(column_name, n, levels, continuous, flip = FALSE)
      
      df_contrib <- plot_data$df_contrib
      data_size <- plot_data$data_size

      names <- as.character(df_contrib$items)
      data_waterfall <- tibble(items = labels[1], contrib = score1) |>
        bind_rows(df_contrib)|>
        mutate(contrib = round(contrib * 100, digits = private$digits))

      n_bars <- nrow(data_waterfall) + 1L
      p <- waterfall(
        data_waterfall,
        calc_total = TRUE, total_axis_text = n_bars,
        total_rect_text_color = "black", total_rect_color = "#00BFC4", 
        rect_text_size = private$text_size)
      scale_x <- p@scales$get_scales("x")
      scale_x$labels <- c(data_waterfall$items, labels[2])
      
      bar_rate <- private$compute_bar_height(data_waterfall, data_size, max_score, 
                                             main_item, bar_max_value)

      data_size <- tibble(x = factor(seq_len(n_bars))) |>
        mutate(items = c(labels[1], names, labels[2])) |>
        left_join(data_size, by = "items") |>
        tidyr::replace_na(list(n = 0L)) |>
        mutate(type = factor(type, levels = labels)) |>
        mutate(n = n * bar_rate)
            
      p <- p +
        geom_col(data = data_size, aes(x, n, fill = type), width = 0.7, position = position_dodge()) +
        scale_fill_manual(values = c("#7CAE00", "#C77CFF"), guide = "none")
      p$layers <- append(head(p$layers, -1), tail(p$layers, 1), 1)
      
      current_theme <- ggplot2::theme_get()
      current_theme$text <- element_text(size = 11 * private$text_size)
      p + current_theme + xlab(private$xlab) + ylab(private$ylab)
    },

    #' @description
    #' Generate a Theseus plot for a specified column
    #'
    #' @param column_name The name of the column to visualize.
    #' @param n integer. Maximum number of top contributing subgroups to display.
    #'   Remaining subgroups are aggregated if necessary.
    #' @param main_item string. The subgroup used as the reference for scaling
    #'   the bar heights.
    #' @param bar_max_value numeric. Maximum value for scaling the contribution bars.
    #' @param levels character vector specifying the display order of subgroups
    #' @param continuous list. Configuration for handling continuous variables
    #'   (e.g., number of bins or custom breaks).
    #'
    #' @return A ggplot object representing the Theseus Plot for the specified column.
    #'
    #' @importFrom tidyr replace_na
    #' @importFrom tibble tibble
    #' @importFrom waterfalls waterfall
    plot_flip = function(column_name, n = 10L, main_item = NULL, bar_max_value = NULL,
                         levels = NULL, continuous = continuous_config()) {
      column_name <- rlang::ensym(column_name) |> rlang::as_string()

      labels <- private$labels
      scores <- private$compute_scores(column_name)
      score2 <- scores[2]
      max_score <- max(scores)
      plot_data <- private$prepare_plot_data(column_name, n, levels, continuous, flip = TRUE)
      
      df_contrib <- plot_data$df_contrib
      data_size <- plot_data$data_size
      
      names <- as.character(df_contrib$items)
      data_waterfall <- tibble::tibble(items = labels[2], contrib = score2) |>
        bind_rows(df_contrib)|>
        mutate(contrib = round(contrib * 100, digits = private$digits))

      colors <- if_else(data_waterfall$contrib > 0, "#F8766D", "#00BFC4")
      colors[1] <- "#00BFC4"
      n_bars <- nrow(data_waterfall) + 1L
      p <- waterfall(
        data_waterfall,
        calc_total = TRUE, total_axis_text = n_bars,
        total_rect_text_color = "black", fill_colours = colors,
        fill_by_sign = FALSE, total_rect_color = "#00BFC4",
        rect_text_size = private$text_size) +
        coord_flip()
      scale_x <- p@scales$get_scales("x")
      scale_x$labels <- c(data_waterfall$items, labels[1])
      
      reverse_sign <- function(x) {
        x <- str_replace(x, "\u2212", "-")
        x <- -as.numeric(x)
        x <- as.character(x)
        str_replace(x, "-", "\u2212")
      }

      is_after <- TRUE
      for (i in seq_along(p$layers |> head(-2))) {
        if ("GeomText" %in% class(p$layers[[i]]$geom)) {
          if (is_after) {
            is_after <- FALSE
            next
          }
          p$layers[[i]]$aes_params$label <- reverse_sign(p$layers[[i]]$aes_params$label)
        }
      }

      bar_rate <- private$compute_bar_height(data_waterfall, data_size, max_score, 
                                             main_item, bar_max_value)
      
      data_size <- tibble(x = factor(seq_len(n_bars))) |>
        mutate(items = c(labels[2], names, labels[1])) |>
        left_join(data_size, by = "items") |>
        tidyr::replace_na(list(n = 0L)) |>
        mutate(type = factor(type, levels = rev(labels))) |>
        mutate(n = n * bar_rate)
      
      p <- p +
        geom_col(data = data_size, aes(x, n, fill = type), width = 0.7, position = position_dodge()) +
        scale_fill_manual(values = c("#C77CFF", "#7CAE00"), guide = "none")
      p$layers <- append(head(p$layers, -1), tail(p$layers, 1), 1)
      
      current_theme <- ggplot2::theme_get()
      current_theme$text <- element_text(size = 11 * private$text_size)
      p + current_theme + xlab(private$xlab) + ylab(private$ylab)
    }
  )
)

make_plot_test_ship <- function(labels = c("Before", "After")) {
  data1 <- data.frame(
    group = rep(c("A", "B"), each = 4L),
    y = c(1, 1, 1, 0, 1, 0, 0, 0)
  )
  data2 <- data.frame(
    group = rep(c("A", "B"), each = 4L),
    y = c(1, 0, 0, 0, 0, 0, 0, 0)
  )

  create_ship(data1, data2, y = y, labels = labels)
}

make_many_item_plot_test_ship <- function() {
  items <- paste0("item", seq_len(9L))
  data1 <- data.frame(
    group = rep(items, times = seq_along(items)),
    y = rep(c(0, 1), length.out = sum(seq_along(items)))
  )
  data2 <- data.frame(
    group = rep(items, times = rev(seq_along(items))),
    y = rep(c(1, 0), length.out = sum(seq_along(items)))
  )

  create_ship(data1, data2, y = y, labels = c("Before", "After"))
}

get_size_bar_data <- function(plot) {
  is_col_layer <- vapply(
    plot$layers,
    \(layer) inherits(layer$geom, "GeomCol"),
    logical(1)
  )

  expect_equal(sum(is_col_layer), 1L)
  plot$layers[[which(is_col_layer)]]$data
}

expect_size_bars_at_expected_positions <- function(plot, n_items) {
  is_col_layer <- vapply(
    plot$layers,
    \(layer) inherits(layer$geom, "GeomCol"),
    logical(1)
  )
  built_data <- ggplot2::ggplot_build(plot)$data[[which(is_col_layer)]]
  expected_positions <- c(
    1L,
    rep(seq_len(n_items) + 1L, each = 2L),
    n_items + 2L
  )

  expect_equal(round(as.numeric(built_data$x)), expected_positions)
}

expect_valid_size_bars <- function(size_bar_data, is_flip = FALSE) {
  actual <- size_bar_data |> select(-items)
  
  last_item <- "After"
  if (is_flip) last_item <- "Before"
  levels <- c("Before", "After")
  if (is_flip) levels <- rev(levels)

  expected <- tibble(
    x = c("1", "2", "2", "3", "3", last_item),
    n = c(0, 25, 25, 25, 25, 0),
    type =  factor(c(NA, "Before", "After", "Before", "After", NA), levels = levels)
  )

  expect_equal(actual, expected)
}

expect_size_bars_in_item_order <- function(size_bar_data, is_flip = FALSE) {
  items <- paste0("item", seq_len(9L))
  n_items <- length(items)
  first_label <- "Before"
  last_label <- "After"
  before_size <- seq_len(9L) * 10
  after_size <- rev(seq_len(9L)) * 10

  if (is_flip) {
    items <- rev(items)
    first_label <- "After"
    last_label <- "Before"
    before_size <- rev(before_size)
    after_size <- rev(after_size)
  }

  actual <- size_bar_data |>
    mutate(x = as.character(x)) |>
    select(x, items, n, type)

  expected <- tibble(
    x = c(
      "1",
      rep(as.character(seq_along(items) + 1L), each = 2L),
      as.character(n_items + 2L)
    ),
    items = c(first_label, rep(items, each = 2L), last_label),
    n = c(0, as.vector(rbind(before_size, after_size)), 0),
    type = factor(
      c(NA, rep(c("Before", "After"), times = n_items), NA),
      levels = if (is_flip) c("After", "Before") else c("Before", "After")
    )
  )

  expect_equal(actual, expected)
}

test_that("plot() retains axis labels with waterfalls 1.1.4", {
  ship <- make_plot_test_ship()

  plot <- ship$plot(group)
  panel <- ggplot2::ggplot_build(plot)$layout$panel_params[[1]]

  expect_equal(panel$x$get_labels(), c("Before", "A", "B", "After"))
})

test_that("plot_flip() retains axis labels with waterfalls 1.1.4", {
  ship <- make_plot_test_ship()

  plot <- ship$plot_flip(group)
  panel <- ggplot2::ggplot_build(plot)$layout$panel_params[[1]]

  expect_equal(panel$y$get_labels(), c("After", "B", "A", "Before"))
})

test_that("plot() supports numeric group labels", {
  ship <- make_plot_test_ship(labels = c(1, 2))

  plot <- ship$plot(group)
  panel <- ggplot2::ggplot_build(plot)$layout$panel_params[[1]]

  expect_equal(panel$x$get_labels(), c("1", "A", "B", "2"))
})

test_that("plot_flip() supports numeric group labels", {
  ship <- make_plot_test_ship(labels = c(1, 2))

  plot <- ship$plot_flip(group)
  panel <- ggplot2::ggplot_build(plot)$layout$panel_params[[1]]

  expect_equal(panel$y$get_labels(), c("2", "B", "A", "1"))
})

test_that("plot() keeps size bars ordered with nine subgroups", {
  ship <- make_many_item_plot_test_ship()
  items <- paste0("item", seq_len(9L))

  plot <- ship$plot(
    group,
    levels = items,
    bar_max_value = 90
  )
  size_bar_data <- get_size_bar_data(plot)

  expect_size_bars_in_item_order(size_bar_data)
  expect_size_bars_at_expected_positions(plot, length(items))
})

test_that("plot_flip() keeps size bars ordered with nine subgroups", {
  ship <- make_many_item_plot_test_ship()
  items <- paste0("item", seq_len(9L))

  plot <- ship$plot_flip(
    group,
    levels = items,
    bar_max_value = 90
  )
  size_bar_data <- get_size_bar_data(plot)

  expect_size_bars_in_item_order(size_bar_data, is_flip = TRUE)
  expect_size_bars_at_expected_positions(plot, length(items))
})

make_factor_order_ship <- function() {
  segment_order <- c("Low", "Medium", "High")
  
  data1 <- data.frame(
    segment = factor(
      c("Low", "Low", "Medium", "Medium", "High", "High"),
      levels = segment_order
    ),
    y = c(1, 1, 1, 0, 1, 1)
  )
  
  data2 <- data.frame(
    segment = factor(
      c("Low", "Low", "Medium", "Medium", "High", "High"),
      levels = segment_order
    ),
    y = c(1, 0, 1, 1, 0, 0)
  )
  
  create_ship(data1, data2, y = y)
}

get_factor_order_size_bar_items <- function(plot) {
  is_col_layer <- vapply(
    plot$layers,
    \(layer) inherits(layer$geom, "GeomCol"),
    logical(1)
  )

  as.character(plot$layers[[which(is_col_layer)]]$data$items)
}

test_that("table() respects factor level order", {
  segment_order <- c("Low", "Medium", "High")
  ship <- make_factor_order_ship()
  tbl <- ship$table(segment)
  
  expect_s3_class(tbl$segment, "factor")
  expect_identical(as.character(tbl$segment), segment_order)
  expect_equal(levels(tbl$segment), segment_order)
})

test_that("plots respect factor level order", {
  plot <- make_factor_order_ship()$plot(segment)
  panel <- ggplot2::ggplot_build(plot)$layout$panel_params[[1]]

  expect_equal(
    panel$x$get_labels(),
    c("Baseline", "Low", "Medium", "High", "Comparison")
  )
  expect_equal(
    get_factor_order_size_bar_items(plot),
    c("Baseline", rep(c("Low", "Medium", "High"), each = 2L), "Comparison")
  )
})

test_that("flipped plots reverse factor level order", {
  plot <- make_factor_order_ship()$plot_flip(segment)
  panel <- ggplot2::ggplot_build(plot)$layout$panel_params[[1]]

  expect_equal(
    panel$y$get_labels(),
    c("Comparison", "High", "Medium", "Low", "Baseline")
  )
  expect_equal(
    get_factor_order_size_bar_items(plot),
    c("Comparison", rep(c("High", "Medium", "Low"), each = 2L), "Baseline")
  )
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ship_of_theseus.R
\name{ShipOfTheseus}
\alias{ShipOfTheseus}
\title{An R6 Class for Generating Theseus Plot}
\description{
The \code{ShipOfTheseus} class decomposes the difference in outcome rates
between two datasets. For a selected column, it computes subgroup
contributions, summarizes the results in tables, and visualizes them as
waterfall-style Theseus Plots.
}
\section{Methods}{
\subsection{Public methods}{
  \itemize{
    \item \href{#method-ShipOfTheseus-initialize}{\code{ShipOfTheseus$new()}}
    \item \href{#method-ShipOfTheseus-table}{\code{ShipOfTheseus$table()}}
    \item \href{#method-ShipOfTheseus-plot}{\code{ShipOfTheseus$plot()}}
    \item \href{#method-ShipOfTheseus-plot_flip}{\code{ShipOfTheseus$plot_flip()}}
    \item \href{#method-ShipOfTheseus-clone}{\code{ShipOfTheseus$clone()}}
  }
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ShipOfTheseus-initialize"></a>}}
\if{latex}{\out{\hypertarget{method-ShipOfTheseus-initialize}{}}}
\subsection{\code{ShipOfTheseus$new()}}{
  The constructor of the \code{ShipOfTheseus} class.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{ShipOfTheseus$new(data1, data2, outcome, labels, xlab, ylab, digits, text_size)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{data1}}{data frame representing the first group (e.g., the baseline
data).}
      \item{\code{data2}}{data frame representing the second group (e.g., the
comparison data).}
      \item{\code{outcome}}{string specifying the outcome variable used to compute the
rate metric (default is \code{"y"}). Typically, this is a binary
indicator (e.g., 0/1) that is aggregated to form rates.}
      \item{\code{labels}}{character vector of length 2 giving the labels for the two
groups. The first corresponds to \code{data1}, the second to
\code{data2}. Default is \code{c("Baseline", "Comparison")}.}
      \item{\code{xlab}}{string specifying the x-axis label for plots. If \code{NULL}
(default), no label is displayed.}
      \item{\code{ylab}}{string specifying the y-axis label for plots. If \code{NULL}
(default), no label is displayed.}
      \item{\code{digits}}{integer indicating the number of decimal places to use for
displaying numeric values (default is \code{1}).}
      \item{\code{text_size}}{numeric value specifying the relative size of text
elements in plots (default is \code{1.0}).}
    }
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    A \code{ShipOfTheseus} object, which can be used with
  \code{plot()} to create Theseus plots.
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ShipOfTheseus-table"></a>}}
\if{latex}{\out{\hypertarget{method-ShipOfTheseus-table}{}}}
\subsection{\code{ShipOfTheseus$table()}}{
  Generate a contribution table for a given column.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{ShipOfTheseus$table(column_name, n = Inf, continuous = continuous_config())}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{column_name}}{string. The name of the column to analyze.}
      \item{\code{n}}{integer. Maximum number of top contributing subgroups to display.
If the number of subgroups exceeds `n`, the remaining are aggregated.}
      \item{\code{continuous}}{list. A configuration list for handling continuous
variables (e.g., specifying number of bins or custom breaks).}
    }
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    A tibble summarizing subgroup contributions to the difference
  between the two groups, including counts, total outcomes, and rates
  for each subgroup.
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ShipOfTheseus-plot"></a>}}
\if{latex}{\out{\hypertarget{method-ShipOfTheseus-plot}{}}}
\subsection{\code{ShipOfTheseus$plot()}}{
  Generate a Theseus plot for a specified column
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{ShipOfTheseus$plot(
  column_name,
  n = 10L,
  main_item = NULL,
  bar_max_value = NULL,
  levels = NULL,
  continuous = continuous_config()
)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{column_name}}{The name of the column to visualize.}
      \item{\code{n}}{integer. Maximum number of top contributing subgroups to display.
Remaining subgroups are aggregated if necessary.}
      \item{\code{main_item}}{string. The subgroup used as the reference for scaling
the bar heights.}
      \item{\code{bar_max_value}}{numeric. Maximum value for scaling the contribution bars.}
      \item{\code{levels}}{character vector specifying the display order of subgroups.}
      \item{\code{continuous}}{list. Configuration for handling continuous variables
(e.g., number of bins or custom breaks).}
    }
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    A ggplot object representing the Theseus Plot for the specified column.
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ShipOfTheseus-plot_flip"></a>}}
\if{latex}{\out{\hypertarget{method-ShipOfTheseus-plot_flip}{}}}
\subsection{\code{ShipOfTheseus$plot_flip()}}{
  Generate a Theseus plot for a specified column
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{ShipOfTheseus$plot_flip(
  column_name,
  n = 10L,
  main_item = NULL,
  bar_max_value = NULL,
  levels = NULL,
  continuous = continuous_config()
)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{column_name}}{The name of the column to visualize.}
      \item{\code{n}}{integer. Maximum number of top contributing subgroups to display.
Remaining subgroups are aggregated if necessary.}
      \item{\code{main_item}}{string. The subgroup used as the reference for scaling
the bar heights.}
      \item{\code{bar_max_value}}{numeric. Maximum value for scaling the contribution bars.}
      \item{\code{levels}}{character vector specifying the display order of subgroups}
      \item{\code{continuous}}{list. Configuration for handling continuous variables
(e.g., number of bins or custom breaks).}
    }
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    A ggplot object representing the Theseus Plot for the specified column.
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ShipOfTheseus-clone"></a>}}
\if{latex}{\out{\hypertarget{method-ShipOfTheseus-clone}{}}}
\subsection{\code{ShipOfTheseus$clone()}}{
  The objects of this class are cloneable with this method.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{ShipOfTheseus$clone(deep = FALSE)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{deep}}{Whether to make a deep clone.}
    }
    \if{html}{\out{</div>}}
  }
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_ship.R
\name{create_ship}
\alias{create_ship}
\title{Creates a Ship Object for Generating Theseus Plots}
\usage{
create_ship(
  data1,
  data2,
  y = "y",
  labels = c("Baseline", "Comparison"),
  xlab = NULL,
  ylab = NULL,
  digits = 1L,
  text_size = 1
)
}
\arguments{
\item{data1}{data frame representing the first group (e.g., the baseline
data).}

\item{data2}{data frame representing the second group (e.g., the comparison
data).}

\item{y}{column name specifying the outcome variable used to compute the rate
metric (default is \code{"y"}). Typically, this is a binary indicator
(e.g., 0/1) that is aggregated to form rates.}

\item{labels}{character vector of length 2 giving the labels for the two
groups. The first corresponds to \code{data1}, the second to \code{data2}.
Default is \code{c("Baseline", "Comparison")}.}

\item{xlab}{string specifying the x-axis label for plots. If \code{NULL}
(default), no label is displayed.}

\item{ylab}{string specifying the y-axis label for plots. If \code{NULL}
(default), no label is displayed.}

\item{digits}{integer indicating the number of decimal places to use for
displaying numeric values (default is \code{1}).}

\item{text_size}{numeric value specifying the relative size of text elements
in plots (default is \code{1.0}).}
}
\value{
A \link{ShipOfTheseus} object, which can be used with \code{plot()}
  to create Theseus plots.
}
\description{
Creates a ship object, which serves as a container for data and methods to
generate Theseus plots for decomposing differences in rate metrics.
}
\examples{
library(dplyr)
library(TheseusPlot)

data <- nycflights13::flights |>
  filter(!is.na(arr_delay)) |>
  mutate(on_time = arr_delay <= 0)

data1 <- data |> filter(month == 1)
data2 <- data |> filter(month == 2)

create_ship(data1, data2, y = on_time)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{continuous_config}
\alias{continuous_config}
\title{Continuous Variable Configuration for Theseus Plot}
\usage{
continuous_config(
  n = 10L,
  pretty = TRUE,
  split = c("count", "width", "rate"),
  breaks = NULL
)
}
\arguments{
\item{n}{integer. Number of bins to create for a continuous variable.}

\item{pretty}{logical. If TRUE, use pretty breaks for bin edges.}

\item{split}{string. Method for binning continuous variables. Options are:
\describe{
  \item{\code{"count"}}{divide the variable into bins with roughly equal number of observations.}
  \item{\code{"width"}}{divide the range of the variable into equal-width bins.}
  \item{\code{"rate"}}{divide based on differences in outcome rates between bins.}
}}

\item{breaks}{numeric vector specifying custom break points.}
}
\value{
A list containing binning parameters (\code{n}, \code{pretty},
  \code{split}, \code{breaks}) to be used in plotting or contribution
  calculations for continuous variables.
}
\description{
The \code{continuous_config()} function creates a configuration object for
handling continuous variables in Theseus plots. It controls how continuous
data is binned into discrete categories for contribution calculations and
visualization.
}
\examples{
library(TheseusPlot)
continuous_config(n = 5, pretty = FALSE, split = "rate")

}
